=== debian/changelog ===
hydrogen (0.9.7-6) unstable; urgency=medium

  * Extend patch 2001 to contain no builtin default feed URL.

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 19 Sep 2017 21:56:43 +0200

hydrogen (0.9.7-5) unstable; urgency=medium

  * Fix install all architecture-independent data in hydrogen-data.
    Bump breaks+replaces.
  * Fix install appdata below /usr/share/metainfo.
  * Limit patch 2001 to patch config file (not builtin defaults.
    Thanks to IOhannes m zmölnig.
  * Tighten lintian overrides regarding License-Reference.
  * Declare compliance with Debian Policy 4.1.0.
  * Add lintian override for separation of command from desktop file.

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 19 Sep 2017 20:10:16 +0200

hydrogen (0.9.7-4) unstable; urgency=medium

  * Fix missing DEP-3 headers for patch 1000 (seems from git commits
    that I wrote that patch, although I don't remember it).
  * Add README.Debian documenting deviation from upstream regarding
    online downloadable drumkit feeds.
    Thanks to IOhannes m zmölnig.
  * Tidy rules file: Reorganize package relations variables.
  * Add patch cherry-picked upstream to fix crash enabling rubberband
    with new empty instrument component.

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 18 Sep 2017 23:14:30 +0200

hydrogen (0.9.7-3) unstable; urgency=medium

  * Add patch 2001 to offer live download of only free drumkits by
    default.
  * Modernize Vcs-* fields: Use git (not cgit) in path.
  * Declare compliance with Debian Policy 4.0.1.

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 16 Aug 2017 21:04:32 +0200

hydrogen (0.9.7-2) unstable; urgency=medium

  [ Sebastian Ramacher ]
  * Remove unused B-D on libaudiofile-dev.

  [ Jonas Smedegaard ]
  * Fix drop README.source section about special care for CDBS: Directly
    contradicts section emphasizing that *no* special care is needed
    (CDBS users handle merges).
  * Revert to debhelper compatibility level 9: No concrete need, and may
    complicate backortability.
  * Update patches:
    + Refresh with shortening quilt options.
  * Update copyright info:
    + List Github as source.
    + List Github issue tracker as preferred upstream contact.
    + Use https protocol in initial format line.
    + Fix double-space delimit copyright holders.
    + Merge equally licensed Files sections.
    + Fix reduce coverage for Jonathan Dempsey.
    + Fix list all authors of ladspa headers.
    + Fix cover wasp plugin, cmake scripts, and another author of main
      upstream source.
    + Fix cover a file where license is guessed.
    + Use License-Grant and License-Reference fields.
      Thanks to Ben Finney.
    + Extend coverage of packaging.
    + Relicense packaging as GPL-3+.
  * Update watch file:
    + Bump to version 4.
    + Mention gpb in usage comment.
    + Add filenamemangle.
    + Tighten uversionmangle.
    + Tighten version match.
  * Update package relations:
    + Relax to build-depend unversioned on libsndfile1-dev: Needed
      version satisfied even in oldstable.
  * Improve copyright-check:
    + Move to manually invoked script in source (not run during build).
      Stop build-depend on licensecheck.
    + Extract metadata from spreadsheets (not only images).
    + Skip images and audio without metadata.
    + Skip more types of compiled localizations.
  * Drop TODO about manpage generation peculiarity: Upstream shipped
    manpage used since 0.9.7-1.
  * Add lintian overrides regarding license in License-Reference field.
    See bug#786450.
  * Modernize cdbs:
    + Drop build target get-orig-source: Use gbp import-orig --uscan.
  * Install only compiled machine-readable locale files (not XML nor
    maintenance tools).
    Drop (wrong) lintian suppression about installed maintenance tools.
  * Suggest ladspa-plugin.
  * (Re)generate locale files from code sources during build.
  * Advertise DEP3 format in patch headers.
  * Add patch 1002 to include ca locale when regenerating translations.

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 21 Jul 2017 08:38:57 +0200

hydrogen (0.9.7-1) unstable; urgency=medium

  * New upstream version 0.9.7
  * Split package.
    * hydrogen - binary
    * hydrogen-data * architecture-independent data files
                    * demo_songs, drumkits, translations
    * hydrogen-doc  * documentation
  * debian/patches
    * Patches refreshed.
    * Renumbering patches.
    * Add patch to fix install path for upstream man pages.
    * 1008-desktop.patch not needed anymore.
    * portaudio patch refreshed/enabled.
    * Add patch fixing CXX FLAGS.
    * Add spelling patch.
    * Patches forwarded.
  * debian/control
    * Bump Standards.
    * Fix VCS fields.
    * Add me as uploader also to control.in file.
  * debian/copyright
    * Update copyright_hints.
    * Update copyright file.
  * debian/rules
    * Fix hardening.
    * Set dh/compat 10.
  * Remove menu file.
  * Improve README.source file.
  * Set section doc for doc package.
  * Add link to SVG icon. (Closes: #795474)
  * Build docs. (Closes: #629107)
    * Thanks to James Cowgill!
  * Set libportmidi-dev linux-any to build on non-linux archs (Closes: #591301).
  * Add hydrogen-data.lintian-overrides file.
  * Don't create xmp icon.
  * Not install xpm icon any more.
  * Remove B-D for image conversion - not needed any more.
  * Don't sign tags.
  * Handle upstream git files by d/gbp.conf rather then d/copyright.
  * Install upstream man pages and hydrogen.appdata.xml.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Tue, 29 Nov 2016 22:01:10 +0000
