## hydrogen 1.0.0~beta1

=== debian/changelog ===
hydrogen (1.0.0~beta1-0ubuntu1) focal; urgency=medium

  * New upstream version 1.0.0-beta1 (required for Qt4 removal)
  * Bump standards, compat to 10 for CDBS compatibility
  * Add self to debian/copyright
  * Update build for python
  * Patch to remove beta nag

 -- Erich Eickmeyer <erich@ericheickmeyer.com>  Wed, 06 Nov 2019 07:36:33 -0800
