=== debian/control ===
--- 
+++ 
@@ -1,8 +1,10 @@
 Source: hydrogen
 Section: sound
 Priority: optional
-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Erich Eickmeyer <erich@ericheickmeyer.com>
 Uploaders:
+ Erich Eickmeyer <erich@ericheickmeyer.com>,
  Jonas Smedegaard <dr@jones.dk>,
  Jaromír Mikeš <mira.mikes@seznam.cz>
 Build-Depends:
@@ -10,25 +12,30 @@
  debhelper,
  dh-buildinfo,
  cmake,
- libqt4-dev,
+ qtbase5-dev,
  libz-dev,
  pkg-config,
  libarchive-dev,
  docbook-utils,
  poxml,
  xmlto,
+ ladspa-sdk,
+ libqt5xmlpatterns5-dev,
  libxml2-utils,
  libasound2-dev [linux-any],
- libjack-dev,
+ libjack-jackd2-dev,
  liblrdf-dev,
+ liblo-dev,
  libsndfile1-dev,
+ libtar-dev,
  portaudio19-dev,
+ qttools5-dev-tools,
  libportmidi-dev [linux-any],
  libpulse-dev
-Standards-Version: 4.1.0
+Standards-Version: 4.3.0
 Homepage: http://www.hydrogen-music.org/
-Vcs-Git: https://anonscm.debian.org/git/pkg-multimedia/hydrogen.git
-Vcs-Browser: https://anonscm.debian.org/git/pkg-multimedia/hydrogen.git
+Vcs-Git: https://salsa.debian.org/multimedia-team/hydrogen.git
+Vcs-Browser: https://salsa.debian.org/multimedia-team/hydrogen
 
 Package: hydrogen
 Architecture: any
@@ -48,7 +55,7 @@
  .
  General features:
   * Very user-friendly, modular, fast and intuitive graphical interface
-    based on QT 4.
+    based on QT 5.
   * Sample-based stereo audio engine, with import of sound samples in
     .wav, .au and .aiff formats.
   * Support of samples in compressed FLAC file.
@@ -66,7 +73,7 @@
   * Multiple patterns playing at once.
  .
  Other features:
-  * JACK, ALSA, PortAudio and OSS audio drivers.
+  * JACK, ALSA, PortAudio, OSS and PulseAudio audio drivers.
   * ALSA MIDI and PortMidi input with assignable midi-in channel (1..16,
     ALL).
   * Import/export of drumkits.
@@ -78,8 +85,8 @@
 Multi-Arch: foreign
 Depends: ${misc:Depends}
 Recommends: hydrogen
-Breaks: hydrogen (<< 0.9.7-5~)
-Replaces: hydrogen (<< 0.9.7-5~)
+Breaks: hydrogen (<< 1.0.0~)
+Replaces: hydrogen (<< 1.0.0-0~)
 Description: advanced drum machine/step sequencer (data)
  Hydrogen is an advanced drum machine.  It's main goal is to bring
  professional yet simple and intuitive pattern-based drum programming.
@@ -91,8 +98,8 @@
 Architecture: all
 Multi-Arch: foreign
 Depends: ${misc:Depends}
-Breaks: hydrogen (<< 0.9.7-1~)
-Replaces: hydrogen (<< 0.9.7-1~)
+Breaks: hydrogen (<< 1.0.0~)
+Replaces: hydrogen (<< 1.0.0~)
 Description: advanced drum machine/step sequencer (doc)
  Hydrogen is an advanced drum machine.  It's main goal is to bring
  professional yet simple and intuitive pattern-based drum programming.
