## hydrogen 1.0.0~beta2

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 # CMAKE SETUP
 #
 
-CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
+CMAKE_MINIMUM_REQUIRED(VERSION 2.8.11)
 SET(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})
 # The CMake Policy mechanism is designed to help keep existing projects building as new versions of CMake introduce changes in behavior.
 # http://www.cmake.org/cmake/help/cmake2.6docs.html#command:cmake_policy
@@ -16,21 +16,21 @@
 # PROJECT INFO
 #
 PROJECT(hydrogen)
-SET(VERSION_MAJOR "0")
-SET(VERSION_MINOR "9")
-SET(VERSION_PATCH "7")
-#SET(VERSION_SUFFIX "rc1")
+SET(VERSION_MAJOR "1")
+SET(VERSION_MINOR "0")
+SET(VERSION_PATCH "0")
+SET(VERSION_SUFFIX "beta2")
 
 SET(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")
 
-SET(DISPLAY_VERSION "${VERSION}")
-
-#IF(VERSION_SUFFIX)
-#	SET(DISPLAY_VERSION "${VERSION}-${VERSION_SUFFIX}")
-#ELSE() 
-#	EXECUTE_PROCESS(COMMAND git log --pretty=format:'%h' -n 1 OUTPUT_VARIABLE GIT_REVISION )
-#	SET(DISPLAY_VERSION "${VERSION}-${GIT_REVISION}")
-#ENDIF(VERSION_SUFFIX)
+IF(VERSION_SUFFIX)
+	SET(DISPLAY_VERSION "${VERSION}-${VERSION_SUFFIX}")
+ELSE()
+	EXECUTE_PROCESS(COMMAND git log --pretty=format:'%h' -n 1 OUTPUT_VARIABLE GIT_REVISION )
+	SET(DISPLAY_VERSION "${VERSION}-${GIT_REVISION}")
+ENDIF(VERSION_SUFFIX)
+
+include(GNUInstallDirs)
 
 SET(LIBSNDFILE_VERSION_PREV "1.0.17")
 
@@ -39,22 +39,23 @@
 #
 SET(WANT_LIBTAR TRUE)
 OPTION(WANT_DEBUG           "Build with debug information" ON)
-
 IF(APPLE)
     OPTION(WANT_SHARED      "Build the core library shared." OFF)
+    OPTION(WANT_ALSA        "Include ALSA (Advanced Linux Sound Architecture) support" OFF)
 ELSE()
     OPTION(WANT_SHARED      "Build the core library shared." ON)
+    OPTION(WANT_ALSA        "Include ALSA (Advanced Linux Sound Architecture) support" ON)
 ENDIF()
 
 OPTION(WANT_LIBARCHIVE      "Enable use of libarchive instead of libtar" ON)
 OPTION(WANT_LADSPA          "Enable use of LADSPA plugins" ON)
 
 IF(APPLE)
-	OPTION(WANT_NSMSESSION  "Enable NSM Session integration" OFF)
+	OPTION(WANT_OSC  "Enable OSC support" OFF)
 	OPTION(WANT_JACKSESSION "Enable use of Jack-Session-Handler" OFF)
 ELSE()
 	OPTION(WANT_JACKSESSION "Enable use of Jack-Session-Handler" ON)
-	OPTION(WANT_NSMSESSION  "Enable NSM Session integration" ON)
+	OPTION(WANT_OSC  "Enable OSC support" ON)
 ENDIF()
 
 IF("${CMAKE_SYSTEM_NAME}" MATCHES "NetBSD")
@@ -63,16 +64,14 @@
 	OPTION(WANT_OSS          "Include OSS (Open Sound System) support" OFF)
 ENDIF()
 
-OPTION(WANT_ALSA         "Include ALSA (Advanced Linux Sound Architecture) support" ON)
 IF(MINGW)
-	OPTION(WANT_JACK         "Include JACK (Jack Audio Connection Kit) support" ON)
 	OPTION(WANT_PORTAUDIO    "Include PortAudio support" ON)
 	OPTION(WANT_PORTMIDI     "Include PortMidi support" ON)
 ELSE()
-	OPTION(WANT_JACK         "Include JACK (Jack Audio Connection Kit) support" ON)
 	OPTION(WANT_PORTAUDIO    "Include PortAudio support" OFF)
 	OPTION(WANT_PORTMIDI     "Include PortMidi support" OFF)
 ENDIF()
+OPTION(WANT_JACK         "Include JACK (Jack Audio Connection Kit) support" ON)
 OPTION(WANT_PULSEAUDIO   "Include PulseAudio support" ON)
 OPTION(WANT_LASH         "Include LASH (Linux Audio Session Handler) support" OFF)
 OPTION(WANT_LRDF         "Include LRDF (Lightweight Resource Description Framework with special support for LADSPA plugins) support" OFF)
@@ -105,8 +104,12 @@
     SET(H2CORE_LIBRARY_TYPE STATIC)
 ENDIF()
 
-#SET(CMAKE_CXX_FLAGS "-fno-implement-inlines -finline-small-functions -findirect-inlining -fpartial-inlining")
-SET(CMAKE_CXX_FLAGS "-O2 -std=gnu++11 -Wno-deprecated-register")
+IF(WANT_DEBUG)
+	SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O0")
+ELSE()
+	SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O2")
+ENDIF()
+
 IF (NOT CMAKE_CXX_COMPILER_ID MATCHES "Clang")
     SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-implement-inlines")
 ENDIF()
@@ -124,39 +127,37 @@
 # MANDATORY PKGS AND DEFAULT OPTIONS
 #
 INCLUDE(StatusSupportOptions)
-MANDATORY_PKG(QT4)
 MANDATORY_PKG(Threads)
 MANDATORY_PKG(LIBSNDFILE)
 
-IF(MINGW)
-    SET(WANT_JACK TRUE)
-    SET(Threads_PATH "C:/Program Files/GnuWin32")
-    SET(LIBARCHIVE_PATH "C:/Program Files/GnuWin32")
-    SET(LIBSNDFILE_PATH "C:/Program Files/Mega-Nerd/libsndfile")
-ELSE(MINGW)
-    IF(APPLE)
-		INCLUDE_DIRECTORIES("/opt/local/include")
-        LINK_DIRECTORIES("/opt/local/lib")
-
-		#Without setting this, installation would go into /usr/local, which does not exist per default
-		SET(CMAKE_INSTALL_PREFIX "/usr" )
-    ELSE(APPLE)
-        SET(OSS_LIB_PATHS "/usr/lib${LIB_SUFFIX}/oss/lib" "/usr/local/lib${LIB_SUFFIX}/oss/lib" )
-        SET(RUBBERBAND_INCLUDE_PATHS "/usr/include/rubberband" )
-    ENDIF(APPLE)
-ENDIF(MINGW)
-
-#Installation paths 
+# http://doc.qt.io/qt-5/cmake-manual.html
+FIND_PACKAGE(Qt5Widgets REQUIRED)
+FIND_PACKAGE(Qt5Xml REQUIRED)
+FIND_PACKAGE(Qt5XmlPatterns REQUIRED)
+FIND_PACKAGE(Qt5LinguistTools REQUIRED)
+set(CMAKE_AUTOMOC ON)
+set(CMAKE_AUTOUIC ON)
+
+IF(APPLE)
+    INCLUDE_DIRECTORIES("/opt/local/include")
+    LINK_DIRECTORIES("/opt/local/lib")
+
+    #Without setting this, installation would go into /usr/local, which does not exist per default
+    SET(CMAKE_INSTALL_PREFIX "/usr" )
+ELSE(APPLE)
+    SET(OSS_LIB_PATHS "${CMAKE_INSTALL_FULL_LIBDIR}/oss/lib" "/usr/local/lib${LIB_SUFFIX}/oss/lib" )
+ENDIF(APPLE)
+
+
+#Installation paths
 # TODO remove data from path
-SET(SYS_DATA_PATH "${CMAKE_INSTALL_PREFIX}/share/hydrogen/data")
+SET(H2_SYS_PATH "${CMAKE_INSTALL_FULL_DATAROOTDIR}/hydrogen")
 # TODO remove data from path, could be .config/hydrogen
-SET(USR_DATA_PATH ".hydrogen/data")
-
+SET(H2_USR_PATH ".hydrogen")
 
 SET(MAX_INSTRUMENTS 1000 CACHE STRING "Maximum number of instruments")
 SET(MAX_COMPONENTS  32   CACHE STRING "Maximum number of components")
 SET(MAX_NOTES       192  CACHE STRING "Maximum number of notes")
-SET(MAX_LAYERS      16   CACHE STRING "Maximum number of layers")
 SET(MAX_FX          4    CACHE STRING "Maximum number of effects")
 SET(MAX_BUFFER_SIZE 8192 CACHE STRING "Maximum size of buffer")
 
@@ -196,7 +197,7 @@
 FIND_HELPER(ALSA alsa alsa/asoundlib.h asound )
 FIND_LADSPA(LADSPA ladspa.h noise)
 
-FIND_HELPER(NSMSESSION liblo lo/lo.h lo)
+FIND_HELPER(OSC liblo lo/lo.h lo)
 
 IF("${CMAKE_SYSTEM_NAME}" MATCHES "NetBSD")
 	FIND_HELPER(OSS oss sys/soundcard.h ossaudio )
@@ -215,35 +216,37 @@
 ENDIF()
 FIND_HELPER(PORTAUDIO portaudio-2.0 portaudio.h portaudio)
 FIND_HELPER(PORTMIDI portmidi portmidi.h portmidi)
-FIND_HELPER(PULSEAUDIO pulseaudio pulse/pulseaudio.h pulse)
+FIND_HELPER(PULSEAUDIO libpulse pulse/pulseaudio.h pulse)
 FIND_HELPER(LASH lash-1.0 lash/lash.h lash)
 FIND_HELPER(LRDF lrdf lrdf.h lrdf)
-FIND_HELPER(RAPTOR raptor2 raptor.h raptor)
-
-FIND_HELPER(RUBBERBAND rubberband RubberBandStretcher.h rubberband)
+
+FIND_HELPER(RUBBERBAND rubberband rubberband/RubberBandStretcher.h rubberband)
 FIND_HELPER(CPPUNIT cppunit cppunit/TestCase.h cppunit)
 
-# CHECK FOR Qt4
-SET(QT_USE_QTNETWORK true)
-SET(QT_USE_QTXML true)
-SET(QT_USE_QTGUI true)
-SET(QT_USE_QTXMLPATTERNS true)
-FIND_PACKAGE(Qt4 4.3.0 REQUIRED)
+
+# Find includes in corresponding build directories
+set(CMAKE_INCLUDE_CURRENT_DIR ON)
+# Instruct CMake to run moc automatically when needed.
+#set(CMAKE_AUTOMOC ON)
+
 
 find_package(Doxygen)
 if(DOXYGEN_FOUND)
 	configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
+	add_custom_target(doc_dir ALL COMMAND ${CMAKE_COMMAND}
+		-E make_directory ${CMAKE_CURRENT_BINARY_DIR}/docs)
 	add_custom_target(doc
 		${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
-                WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/docs
-		COMMENT "Generating API documentation with Doxygen" VERBATIM
-		)
+		DEPENDS doc_dir
+		WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/docs
+		COMMENT "Generating API documentation with Doxygen"
+		VERBATIM)
 endif(DOXYGEN_FOUND)
 
 #
 # COMPUTE H2CORE_HAVE_xxx xxx_STATUS_REPORT
 #
-SET(STATUS_LIST LIBSNDFILE LIBTAR LIBARCHIVE LADSPA ALSA OSS JACK JACKSESSION NSMSESSION COREAUDIO COREMIDI PORTAUDIO PORTMIDI PULSEAUDIO LASH LRDF RAPTOR RUBBERBAND CPPUNIT )
+SET(STATUS_LIST LIBSNDFILE LIBTAR LIBARCHIVE LADSPA ALSA OSS JACK JACKSESSION OSC COREAUDIO COREMIDI PORTAUDIO PORTMIDI PULSEAUDIO LASH LRDF RUBBERBAND CPPUNIT )
 FOREACH( _pkg ${STATUS_LIST})
     COMPUTE_PKGS_FLAGS(${_pkg})
 ENDFOREACH()
@@ -274,17 +277,17 @@
 COLOR_MESSAGE("${cyan}Installation Summary${reset}
 --------------------
 * Install Directory            : ${CMAKE_INSTALL_PREFIX}
-* User data path               : ${USR_DATA_PATH}
-* System data path             : ${SYS_DATA_PATH}
+* User path                    : ${H2_USR_PATH}
+* System path                  : ${H2_SYS_PATH}
 * core library build as        : ${H2CORE_LIBRARY_TYPE}
 * debug capabilities           : ${H2CORE_HAVE_DEBUG}
 * macosx bundle                : ${H2CORE_HAVE_BUNDLE}
 * fat build                    : ${WANT_FAT_BUILD}\n"
 )
 
-COLOR_MESSAGE("${cyan}Main librarires${reset}
-* ${purple}libQt${reset}                        : ${QT_VERSION_MAJOR}.${QT_VERSION_MINOR}.${QT_VERSION_PATCH}
-* ${purple}libsndfile${reset}                   : ${LIBSNDFILE_STATUS}
+COLOR_MESSAGE("${cyan}Main librarires${reset}")
+COLOR_MESSAGE("* ${purple}libQt${reset}                        : ${Qt5Widgets_VERSION}")
+COLOR_MESSAGE("* ${purple}libsndfile${reset}                   : ${LIBSNDFILE_STATUS}
 *                                ${LIBSNDFILE_MSG}
 * ${purple}libtar${reset}                       : ${LIBTAR_STATUS}
 * ${purple}libarchive${reset}                   : ${LIBARCHIVE_STATUS}
@@ -297,7 +300,7 @@
 * ${purple}OSS${reset}                          : ${OSS_STATUS}
 * ${purple}JACK${reset}                         : ${JACK_STATUS}
 * ${purple}JACKSESSION${reset}                  : ${JACKSESSION_STATUS}
-* ${purple}NSM Session${reset}                  : ${NSMSESSION_STATUS}   
+* ${purple}OSC${reset}                          : ${OSC_STATUS}
 * ${purple}CoreAudio${reset}                    : ${COREAUDIO_STATUS}
 * ${purple}CoreMidi${reset}                     : ${COREMIDI_STATUS}
 * ${purple}PortAudio${reset}                    : ${PORTAUDIO_STATUS}
@@ -305,7 +308,7 @@
 * ${purple}PulseAudio${reset}                   : ${PULSEAUDIO_STATUS}\n"
 )
 
-COLOR_MESSAGE("${cyan}Usefull extensions${reset}
+COLOR_MESSAGE("${cyan}Useful extensions${reset}
 -----------------------------------------
 * ${purple}LASH${reset}                         : ${LASH_STATUS}
 * ${purple}LRDF${reset}                         : ${LRDF_STATUS}
@@ -331,3 +334,6 @@
 
 find_path( HYDROGEN_INSTALLED NAMES hydrogen/config.h )
 IF( HYDROGEN_INSTALLED )
+    COLOR_MESSAGE("-----------------------------------------------------------------
+${red}IMPORTANT${reset}:
+  previously installed hydrogen headers found in ${HYDROGEN_INSTALLED}
