=== src/tests/CMakeLists.txt ===
--- 
+++ 
@@ -10,9 +10,14 @@
 FILE(GLOB_RECURSE TESTS_SRCS *.cpp)
 link_directories()
 add_executable(tests ${TESTS_SRCS})
+
+SET_PROPERTY(TARGET tests PROPERTY CXX_STANDARD 14)
+
 target_link_libraries(tests
-    hydrogen-core-${VERSION}
+	hydrogen-core-${VERSION}
 	${CPPUNIT_LIBRARIES}
+	Qt5::Core
 )
+
 add_dependencies(tests hydrogen-core-${VERSION})
