=== debian/changelog ===
hydrogen (1.0.0~beta2-0ubuntu1) focal; urgency=medium

  * New upstream version 1.0.0-beta2

 -- Erich Eickmeyer <erich@ericheickmeyer.com>  Wed, 25 Mar 2020 11:40:01 -0700
