=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
  Jonas Smedegaard <dr@jones.dk>,
  Jaromír Mikeš <mira.mikes@seznam.cz>
 Build-Depends:
- cdbs,
+  cdbs,
  debhelper,
  dh-buildinfo,
  cmake,
@@ -29,7 +29,9 @@
  libsndfile1-dev,
  libtar-dev,
  portaudio19-dev,
+ python2,
  qttools5-dev-tools,
+ qttools5-dev,
  libportmidi-dev [linux-any],
  libpulse-dev
 Standards-Version: 4.3.0
@@ -86,7 +88,7 @@
 Depends: ${misc:Depends}
 Recommends: hydrogen
 Breaks: hydrogen (<< 1.0.0~)
-Replaces: hydrogen (<< 1.0.0-0~)
+Replaces: hydrogen (<< 1.0.0~)
 Description: advanced drum machine/step sequencer (data)
  Hydrogen is an advanced drum machine.  It's main goal is to bring
  professional yet simple and intuitive pattern-based drum programming.
