=== debian/rules ===
--- 
+++ 
@@ -27,9 +27,9 @@
 CDBS_BUILD_DEPENDS_rules_utils_copyright-check =
 
 # Needed by upstream build
-bdeps = cmake, libqt4-dev, libz-dev, pkg-config, libarchive-dev
+bdeps = cmake, qtbase5-dev, libz-dev, pkg-config, libarchive-dev
 bdeps +=, docbook-utils, poxml, xmlto, libxml2-utils
-bdeps +=, libasound2-dev [linux-any], libjack-dev, liblrdf-dev
+bdeps +=, libasound2-dev [linux-any], libjack-jackd2-dev, liblrdf-dev
 bdeps +=, libsndfile1-dev, portaudio19-dev, libportmidi-dev [linux-any]
 bdeps +=, libpulse-dev
 
@@ -41,16 +41,7 @@
  -DWANT_RUBBERBAND=ON
 
 # according to upstream INSTALL.txt this avoids potential clash with Qt3
-export QTDIR=/usr/share/qt4
-
-common-build-indep:: debian/docs.stamp
-debian/docs.stamp:
-	$(MAKE) -C data/doc
-	touch $@
-clean::
-	rm -f debian/docs.stamp
-	rm -rf CMakeCache.txt CMakeFiles/ try/
-	rm -f qt4.pyc version.cpp config.h
+export QTDIR=/usr/lib/qt5
 
 # (Re)generate locale files from code sources
 DEB_UPSTREAM_CRUFT_MOVE = usr/share/hydrogen/data/i18n/*.qm
