=== debian/watch ===
# run "uscan --report" to check or "gpb import-orig --uscan" to update
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,uversionmangle=s/(\d)-(alpha|beta|rc)/$1~$2/"
 https://github.com/hydrogen-music/hydrogen/tags \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian
